<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Models\HcpModel;
use Illuminate\Http\Request;
use Log;

class EquelleHCPController extends Controller
{
    private $hcpObj;

    public function __construct() {
        
        $this->hcpObj = new HcpModel();
    }

    /**
     * HCP post request
     */
    public function EquelleHCP(Request $request) {

        $requestData = $request->input('data');
        if (empty($requestData)) {

            $returnData = [
                'error' => 'Invalid endpoint request',
            ];
            $message = 'Failed';
            Log::channel('hcpLog')->info("Error : Invalid endpoint request");
            if (!empty($request->input('callback'))) {
                return $this->returnData($request->input('callback'), '600', $message, $returnData);
            } else {
                return $this->returnData(null, '600', $message, $returnData);
            }
        }
        $receivedData = json_decode($requestData);
        // $requestKeys = ['EMail', 'Title', 'FirstName', 'LastName', 
        // 'NPINumber', 'PracticeName', 'PracticePhone','AddressLine1','City','State','Zipcode'];
        // $keysInTheRequest = [];
        // $emptyValueKeys = [];
        // $nonRequiredFields = ['EMail', 'Title', 'FirstName', 'LastName', 
        // 'NPINumber', 'PracticeName', 'PracticePhone','AddressLine1','City','State','Zipcode'];
        // foreach ($receivedData as $key => $recValue) {

        //     $keysInTheRequest[] = $key;
        //     if (empty($recValue) && !in_array($key, $nonRequiredFields)) {

        //         $emptyValueKeys[] = $key;
        //     }
        // }
        // $keyComparedStatus = array_diff($requestKeys, $keysInTheRequest);
        // if (!empty($keyComparedStatus)) {

        //     $missedParameters = implode(",", $keyComparedStatus);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $missedParameters . ' endpoint parameters are missing in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $missedParameters . ' endpoint parameters are missing in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        // if (!empty($emptyValueKeys)) {

        //     $emptyValueKeys = implode(",", $emptyValueKeys);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $emptyValueKeys . ' endpoint parameter values are empty in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $emptyValueKeys . ' endpoint parameter values are empty in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        $response = $this->hcpObj->postRequestData($requestData);
        if (strtolower(trim($response)) != 'success') {

            $message = 'Failed';
            $returnData = [
                'error' => 'An error occurred while posting the request to the API',
                'request' => $requestData,
            ];
            Log::channel('hcpLog')->info('Error : An error occurred while posting the request to the API (Email: ' . 
            $receivedData->EMail . ')');
            return $this->returnData($request->input('callback'), '600', $message, $returnData);
        }
        $message = 'Success';
        $returnData = [
            'message' => 'Successfully posted the given request in the API (Email: ' . $receivedData->EMail . ')',
        ];
        Log::channel('hcpLog')->info('Success : Successfully posted the given request in the API (Email: ' . 
        $receivedData->EMail . ')');
        //Log::info($returnData);
        return $this->returnData($request->input('callback'), '200', $message, $returnData);
    }

    /**
     * Response message function
     */
    public function returnData($jsonCallback = null, $status, $message, $error) {

        $returnData = array(
            'status' => $status,
            'message' => $message,
            'body' => $error,

        );
        if (!empty($jsonCallback)) {

            echo $jsonCallback . '(' . json_encode($returnData) . ')';
            die();
        } else {

            return response()->json($returnData);
        }
    }
}
