<?php
namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Log;

class HcpModel extends Model 
{

    private $hcp_post_url;

    public function __construct() {

        $this->hcp_post_url = env('POST_HCPFORM_URL', true);
    }

    /**
     * Post request data to API
     */
    public function postRequestData($data) {

        $method = 'POST';
        $path = $this->hcp_post_url;
        $response = $this->call($method, $path, $data);
        return $response;
    }

    /**
     * CURL call
     */
    public function call($method, $path, $data = []) {

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $path);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_ENCODING, '');
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);

        if ($method !== 'GET') {

            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }

        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            "content-type: application/json",
        ));

        $response = curl_exec($curl);
        return $response;
    }
}
